from .feloopy import *
from .operators import *

heuristic_algorithms = ['OriginalEP',
                        'LevyEP',
                        'OriginalES',
                        'LevyES',
                        'OriginalMA',
                        'BaseGA',
                        'SingleGA',
                        'MultiGA',
                        'EliteSingleGA',
                        'EliteMultiGA',
                        'BaseDE',
                        'JADE',
                        'SADE',
                        'SHADE',
                        'L_SHADE',
                        'SAP_DE',
                        'OriginalFPA',
                        'OriginalCRO',
                        'OCRO',
                        'OriginalPSO',
                        'PPSO',
                        'HPSO_TVAC',
                        'C_PSO',
                        'CL_PSO',
                        'OriginalBFO',
                        'ABFO',
                        'OriginalBeesA',
                        'ProbBeesA',
                        'OriginalCSO',
                        'OriginalABC',
                        'OriginalACOR',
                        'OriginalCSA',
                        'OriginalFFA',
                        'OriginalFA',
                        'OriginalBA',
                        'AdaptiveBA',
                        'ModifiedBA',
                        'OriginalFOA',
                        'BaseFOA',
                        'WhaleFOA',
                        'OriginalSSpiderO',
                        'OriginalGWO',
                        'RW_GWO',
                        'OriginalSSpiderA',
                        'OriginalALO',
                        'BaseALO',
                        'OriginalMFO',
                        'BaseMFO',
                        'OriginalEHO',
                        'OriginalJA',
                        'BaseJA',
                        'LevyJA',
                        'OriginalWOA',
                        'HI_WOA',
                        'OriginalDO',
                        'OriginalBSA',
                        'OriginalSHO',
                        'OriginalSSO',
                        'OriginalSRSR',
                        'OriginalGOA',
                        'OriginalCOA',
                        'OriginalMSA',
                        'OriginalSLO',
                        'ModifiedSLO',
                        'ImprovedSLO',
                        'OriginalNMRA',
                        'ImprovedNMRA',
                        'OriginalPFA',
                        'OriginalSFO',
                        'ImprovedSFO',
                        'OriginalHHO',
                        'OriginalMRFO',
                        'OriginalBES',
                        'OriginalSSA',
                        'BaseSSA',
                        'OriginalHGS',
                        'OriginalAO',
                        'GWO_WOA',
                        'OriginalMPA',
                        'OriginalHBA',
                        'OriginalSCSO',
                        'OriginalTSO',
                        'OriginalAVOA',
                        'OriginalAGTO',
                        'OriginalARO',
                        'OriginalSA',
                        'OriginalWDO',
                        'OriginalMVO',
                        'BaseMVO',
                        'OriginalTWO',
                        'OppoTWO',
                        'LevyTWO',
                        'EnhancedTWO',
                        'OriginalEFO',
                        'BaseEFO',
                        'OriginalNRO',
                        'OriginalHGSO',
                        'OriginalASO',
                        'OriginalEO',
                        'ModifiedEO',
                        'AdaptiveEO',
                        'OriginalArchOA',
                        'OriginalCA',
                        'OriginalICA',
                        'OriginalTLO',
                        'BaseTLO',
                        'ITLO',
                        'OriginalBSO',
                        'ImprovedBSO',
                        'OriginalQSA',
                        'BaseQSA',
                        'OppoQSA',
                        'LevyQSA',
                        'ImprovedQSA',
                        'OriginalSARO',
                        'BaseSARO',
                        'OriginalLCO',
                        'BaseLCO',
                        'ImprovedLCO',
                        'OriginalSSDO',
                        'OriginalGSKA',
                        'BaseGSKA',
                        'OriginalCHIO',
                        'BaseCHIO',
                        'OriginalFBIO',
                        'BaseFBIO',
                        'OriginalBRO',
                        'BaseBRO',
                        'OriginalSPBO',
                        'DevSPBO',
                        'OriginalDMOA',
                        'DevDMOA',
                        'OriginalIWO',
                        'OriginalBBO',
                        'BaseBBO',
                        'OriginalVCS',
                        'BaseVCS',
                        'OriginalSBO',
                        'BaseSBO',
                        'OriginalEOA',
                        'OriginalWHO',
                        'OriginalSMA',
                        'BaseSMA',
                        'OriginalBMO',
                        'OriginalTSA',
                        'OriginalSOS',
                        'OriginalSOA',
                        'DevSOA',
                        'OriginalGCO',
                        'BaseGCO',
                        'OriginalWCA',
                        'OriginalAEO',
                        'EnhancedAEO',
                        'ModifiedAEO',
                        'ImprovedAEO',
                        'AdaptiveAEO',
                        'OriginalHC',
                        'SwarmHC',
                        'OriginalCEM',
                        'OriginalSCA',
                        'BaseSCA',
                        'OriginalGBO',
                        'OrginalAOA',
                        'OriginalCGO',
                        'OriginalPSS',
                        'OriginalINFO',
                        'OriginalRUN',
                        'OriginalCircleSA',
                        'OriginalHS',
                        'BaseHS'
                        ]

exact_algorithms = [
    ['gekko', 'apopt'],
    ['ortools', 'bop'],
    ['gekko', 'bpopt'],
    ['pulp', 'cbc'],
    ['ortools', 'glop'],
    ['pymprog', 'glpk'],
    ['gekko', 'ipopt'],
    ['ortools', 'sat'],
    ['ortools', 'scip'],
]

feloopy_algorithms = [
    'GA',
    'SA',
    'TS',
    'DE',
    'GWO'
]